/**
 * Created by rburson on 12/23/15.
 */
import * as React from 'react';
import { CvState, CvProps, CvNavigationResult } from './catreact-core';
import { NavRequest } from 'catavolt-sdk';
export interface CvNavigationState extends CvState {
    visible: boolean;
    navRequest: NavRequest;
}
export interface CvNavigationProps extends CvProps {
    /**
     * The result of a navigation.  Should not be used if the navigationId property is provided
     */
    navigationResult?: CvNavigationResult;
    /**
     * The cache identifier of the result of a Navigation. Should not be used if the navigationResult is provided.
     */
    navigationId?: string;
    /**
     * Setting persistent true, allows this component to remain visible, even after another, new Navigation has
     * taken place.  This is useful for single page apps where components may be coresident.
     */
    persistent?: boolean;
    /**
     * Allows for one Navigation component to target another, when coresident on the page.
     */
    targetId?: string;
}
export declare var CvNavigation: React.ClassicComponentClass<CvNavigationProps>;
