import { CvState, CvProps, CvResultCallback, CvEvent, CvStateChangeResult, CvContext, CvValueProvider, CvActionHandlerParams, CvActionFiredResult } from './catreact-core';
import { FormContext, QueryContext, DialogException } from 'catavolt-sdk';
export interface CvQueryPaneState extends CvState {
}
export declare enum CvQueryMode {
    NORMAL = 0,
    DEFERRED = 1,
    MANUAL = 2,
}
export interface CvQueryPaneProps extends CvProps {
    paneRef?: number;
    formContext?: FormContext;
    queryContext?: QueryContext;
    stateChangeListeners?: Array<(event: CvEvent<CvStateChangeResult>) => void>;
    actionListeners?: Array<(event: CvEvent<CvActionFiredResult>) => void>;
    queryRenderer?: (cvContext: CvContext, callback: CvQueryPaneCallback) => any;
    errorRenderer?: (cvContext: CvContext, dialogException?: DialogException) => {};
    actionProvider?: CvValueProvider<CvActionHandlerParams>;
    recordPageSize?: number;
    queryMode?: CvQueryMode;
}
export interface CvQueryPaneCallback {
    hasMoreBackward(): boolean;
    hasMoreForward(): boolean;
    isInProgress(): boolean;
    pageBackward(resultCallback: CvResultCallback<number>, replaceBuffer?: boolean): void;
    pageForward(resultCallback: CvResultCallback<number>, replaceBuffer?: boolean): void;
    pageSize(): number;
    refresh(): void;
    suppressEvents(suppressEvents: boolean): void;
}
export declare var CvQueryBase: {
    formContext: (nextProps: any, nextContext: any) => any;
    getChildContext: () => any;
    reload: (pageSize: number, nextProps: any, nextContext: any) => void;
    queryContext: (nextProps: any, nextContext: any) => any;
    isInProgress: () => boolean;
    checkReloadNeeded: (nextProps: any, nextContext: any) => void;
    _checkDestroyed: () => void;
    _componentWillMount: () => void;
    _componentWillReceiveProps: (nextProps: any, nextContext: any) => void;
    _componentWillUnmount: () => void;
    _dataChangeListener: (dataChangeResult: CvEvent<CvStateChangeResult>) => void;
    _getCallbackObj: () => CvQueryPaneCallback;
    _getDefaultProps: () => {
        paneRef: any;
        formContext: any;
        queryContext: any;
        queryRenderer: any;
        errorRenderer: any;
        stateChangeListeners: any[];
        actionListeners: any[];
        actionProvider: any;
        recordPageSize: number;
        queryMode: CvQueryMode;
    };
    _handleAction: (params: CvActionHandlerParams) => void;
    _render: () => any;
};
